package com.chy.borrow.config;

import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.config.DataSourceConfig;
import com.baomidou.mybatisplus.generator.config.GlobalConfig;
import com.baomidou.mybatisplus.generator.config.PackageConfig;
import com.baomidou.mybatisplus.generator.config.StrategyConfig;
import com.baomidou.mybatisplus.generator.config.querys.PostgreSqlQuery;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;



/**
 * @version 1.0.0
 * @time 2021/8/2 15:00
 * @auther zk
 */

public class HighgoGenerator {
    public static void main(String[] args) {
        AutoGenerator mpg = new AutoGenerator();
        //1、全局配置
        GlobalConfig gc = new GlobalConfig();
        String projectPath = System.getProperty("user.dir");
        gc.setOutputDir(projectPath + "/src/main/java");  //生成路径(一般都是生成在此项目的src/main/java下面)
        gc.setAuthor("沈晔浩"); //设置作者
        gc.setOpen(false);
        gc.setFileOverride(true); //第二次生成会把第一次生成的覆盖掉
        gc.setServiceName("%sService"); //生成的service接口名字首字母是否为I，这样设置就没有
        gc.setBaseResultMap(true); //生成resultMap
        mpg.setGlobalConfig(gc);
        //2、数据源配置
        DataSourceConfig dsc = new DataSourceConfig();
//        DataSourceConfig dsc = new MyDataSourceConfig();
//        dsc.setDbType(DbType.HIGH_GO);
        dsc.setDbType(DbType.POSTGRE_SQL);
        dsc.setDbQuery(new PostgreSqlQuery());
        dsc.setSchemaName("jygl");
//        dsc.setUrl("jdbc:highgo://192.168.113.229:5866/highgo");
        dsc.setUrl("jdbc:postgresql://47.101.207.123:5432/postgres");
//        dsc.setDriverName("com.highgo.jdbc.Driver");
        dsc.setDriverName("org.postgresql.Driver");
//        dsc.setUsername("highgo");
        dsc.setUsername("postgres");
        dsc.setPassword("Citygis!23");
//        dsc.setUsername("BAYONET_DYNAMIC");
//        dsc.setPassword("Bayonet@123");
        mpg.setDataSource(dsc);

        // 3、包配置
        PackageConfig pc = new PackageConfig();
        pc.setModuleName("borrow");
        pc.setParent("com.chy");
        mpg.setPackageInfo(pc);

        // 4、策略配置
        StrategyConfig strategy = new StrategyConfig();
        strategy.setEntityTableFieldAnnotationEnable(true);
        strategy.setNaming(NamingStrategy.underline_to_camel);
        strategy.setColumnNaming(NamingStrategy.underline_to_camel);
        strategy.setSuperControllerClass("com.chy.borrow.controller.BaseController");
        strategy.setSuperEntityClass("com.chy.borrow.entity.BaseEntity");
        // strategy.setTablePrefix("t_"); // 表名前缀
        strategy.setEntityLombokModel(true); //使用lombok

        String[] tables=new String[]{"borrow_download"};

//        String[] tables=new String[]{"JYGL.TMP_CODE"};

        strategy.setInclude(tables);  // 逆向工程使用的表   如果要生成多个,这里可以传入String[]

        mpg.setStrategy(strategy);
        mpg.setTemplateEngine(new FreemarkerTemplateEngine());
        //5、执行
        mpg.execute();
    }
}
